日記の書き方
======

目次
--

  -
  -

tDiaryの日記フォーマット
---------------

本文には、HTMLで日記を記述します。とは言っても、普通の文章だけの日記を書く分にはHTMLを意識しなくても良いように、HTMLに対して改行や行頭文字に特別なルールを加えたものです。サブタイトルや段落を簡単に指定するためにこのような拡張をしてあります。

以下のようなルールがあります。表示上の改行と実際の改行を区別するために、実際の改行には「_↓_」と書いてあります。

********

 サブタイトル(1)_↓_上記のように行頭から始まる行は、サブタイトルとなります。標準のスタイルシートでは、太字で表示されます。サブタイトルから次の空改行までを「セクション」と呼び、サブタイトルの前にはセクションアンカーが付きます。_↓_上の行やこの行のように、サブタイトル以降の行は通常の文章として認識されます。段落がサブタイトルで始まっている場合には、文章の前にはセクションアンカーはつきません。_↓__↓_　空改行があると、セクションの切り替えを意味します。このように、空白で文章を始めると、サブタイトル抜きでセクションが始まります。最初の段落の先頭にだけセクションアンカーが付きます。サブタイトルのある場合ように太字にはなりません。_↓_　サブタイトルで始まらなくても、2つ目の段落以降にはアンカーは付きません。_↓__↓_```
_↓_このように行の最初が「↓
   
 そのセクションは全体が整形の対象にならなくなります。_↓_次に空改行が現れるまで(つまり次のセクションまで)の文_↓_章はそのままの形でHTML内に展開されます。リストやテー_↓_ブルなどを使いたい場合等、HTMLタグをそのまま使いたい_↓_場面に利用できます。セクションアンカーは付きません。_↓_```
_↓__↓_サブタイトル(2)_↓_必然的に、HTMLタグで始まるサブタイトルがつけられないことになりますが、上記のように「↓
   
********

上記の内容は、以下のように表示されます。

********

[2001-08-03](./?date=20010803)(指定したタイトル)
----------

### [■](./?date=20010803#p01)サブタイトル(1)

上記のように行頭から始まる行は、サブタイトルとなります。標準のスタイルシートでは、太字で表示されます。サブタイトルから次の空改行までを「セクション」と呼び、サブタイトルの前にはセクションアンカーが付きます。

上の行やこの行のように、サブタイトル以降の行は通常の文章として認識されます。段落がサブタイトルで始まっている場合には、文章の前にはセクションアンカーはつきません。

[■](./?date=20010803#p02)　空改行があると、セクションの切り替えを意味します。このように、空白で文章を始めると、サブタイトル抜きでセクションが始まります。最初の段落の先頭にだけセクションアンカーが付きます。サブタイトルのある場合ように太字にはなりません。

　サブタイトルで始まらなくても、2つ目の段落以降にはアンカーは付きません。

```
 このように最初の行が「
### [■](./?date=20010803#p04)[サブタイトル(2)](hogehoge)

必然的に、HTMLタグで始まるサブタイトルがつけられないことになりますが、上記のように「

```

********

このようにtDiaryは、簡単な文章だけからなる日記をつける場合にはHTMLを知らなくても使え、HTMLに詳しい場合にはそれもサポートするようになっています。……が、ときどき不用意にタグを使ってハマる人も少なくないので、日記中でタグを多用する人は次の「tDiary記述のコツ」もお読みください。

tDiary記述のコツ
-----------

### セクションにタグ入りの行を含めたい

例えば日記中にリストを埋め込むために

タグを入れたいとしましょう。話題は同じなのでセクションは変えたくない。このように段落全体を特殊なタグで装飾したい場合、tDiaryでは少しコツが必要です。以下のようなレイアウトをしたい場合を例にとりあげます。
********

[2001-08-29](./?date=20010830)
----------

### [■](./?date=20010829#p01)サブタイトル

　以下のように2つの項目からなるリストを書きます。
    - リスト項目1
    - リスト項目2
　こんな感じです。ここまで同一のセクション。
********

まずひとつの方法は、前の段落に合体させてしまう方法です。生成された日記のHTMLを見ればわかるように、段落というのは〜で囲まれているだけです。これを利用してごまかしを入れます。
********

サブタイトル_↓_　以下のように2つの項目からなるリストを書きます。
    - リスト項目1
    - リスト項目2
　こんな感じです。ここまで同一のセクション。_↓_********

途中でいっさい改行を入れないところがミソです。タグで囲まれた段落が何行にもわたる場合以外はこれでもけっこういけますが、ちょっと見通しが悪いですね。上の例は、tDiaryが段落には自動的にを入れることを利用しています。逆に、タグで始まる行があるセクションにはこのタグ自体を挿入しないことを利用する方法もあります。通常の段落に、手動でタグを入れる方法です。以下の記述例では、セクション中に「〜で囲んでいます。
********

サブタイトル_↓_　以下のように2つの項目からなるリストを書きます。_↓__↓_- リスト項目1
_↓_- リスト項目2
_↓__↓_　こんな感じです。ここまで同一のセクション。_↓_********

この手法は、タグで囲まれた段落が複数行に渡るとき(例えば

```
タグでソースコードを挿入するなど)には必須になるでしょう。もちろん、「セクションが分かれても良い」という場合にはもっと楽になります。こだわりがなければ以下のように書いてしまうのが良いかもしれません。

********

 サブタイトル_↓_　以下のように2つの項目からなるリストを書きます。_↓__↓_```

_↓_- リスト項目1
_↓_- リスト項目2
_↓__↓__↓_　こんな感じです。ここまで同一のセクション。_↓_********

最後の「こんな感じです〜」の行頭にはセクションアンカーが入ってしまいますが、たいして気にする問題でもないでしょう。

### セクション単位でなく、段落単位にアンカーを入れたい

tDiaryは、「話題の単位はセクションにあり、段落にまでアンカーを入れる必要はない」というポリシーで作られているため、基本的には段落にアンカーを入れることはできません。ただし、サブタイトルなしのセクションが作れることを利用すれば、見た目は段落単位にアンカーを入れることもできます。以下の例を見てください:

********

 サブタイトル(1)_↓__↓_　このようにサブタイトルの下にすぐ空改行を入れてしまい、続く段落を空白で始めるようにすれば、サブタイトルと段落は別々のセクションになります。_↓__↓_　段落の間にすべて空改行を入れるようにすれば、このようにすべての段落にアンカーを付けることができるわけです。_↓__↓_サブタイトル(2)_↓__↓_   
 　行頭の空白を入れないとサブタイトルになるので注意しましょう。_↓_
   
********

上の例は以下のように展開されます。ポイントは**行頭の空白**ですね。

********

[2001-08-30](./?date=20010830)
----------

### [■](./?date=20010830#p01)サブタイトル(1)

[■](./?date=20010830#p02)このようにサブタイトルの下にすぐ空改行を入れてしまい、続く段落を空白で始めるようにすれば、サブタイトルと段落は別々のセクションになります。

[■](./?date=20010830#p03)段落の間にすべて空改行を入れるようにすれば、このようにすべての段落にアンカーを付けることができるわけです。

### [■](./?date=20010830#p04)サブタイトル(2)

[■](./?date=20010830#p04)行頭の空白を入れないとサブタイトルになるので注意しましょう。

********

